package de.donmanfred;

import com.google.firebase.database.DatabaseError;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ShortName;

@ShortName("DatabaseError")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onSigned(sign As Object)"})
//@DependsOn(values={"com.android.support:support-v4"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 */

public class DatabaseErrorWrapper extends AbsObjectWrapper<DatabaseError> {
	private BA ba;


	public static final int DATA_STALE = -1;
	public static final int DISCONNECTED = -4;
	public static final int EXPIRED_TOKEN = -6;
	public static final int INVALID_TOKEN = -7;
	public static final int MAX_RETRIES = -8;
	public static final int NETWORK_ERROR = -24;
	public static final int OPERATION_FAILED = -2;
	public static final int OVERRIDDEN_BY_SET = -9;
	public static final int PERMISSION_DENIED = -3;
	public static final int UNAVAILABLE = -10;
	public static final int UNKNOWN_ERROR = -999;
	public static final int USER_CODE_EXCEPTION = -11;
	public static final int WRITE_CANCELED = -25;
	
	public void Initialize(final BA ba, DatabaseError error) {
		this.ba = ba;

		final DatabaseError _obj = error;
		setObject(_obj);
	}

	/**
	 * returns One of the defined status codes, 
	 * depending on the error
	 */
	public int getCode(){
		return getObject().getCode();
	}
	
	/**
	 * returns Human-readable details on the 
	 * error and additional information, 
	 * e.g. links to docs;
	 */
	public String getDetails(){
		return getObject().getDetails();
	}

	/**
	 * returns a human-readable description of the error 
	 */
	public String getMessage(){
		return getObject().getMessage();
	}
     

	
	
}
